IncludeScript("murdermystery/artifact_system.nut")
IncludeScript("murdermystery/roles/Bystanders.nut")
IncludeScript("murdermystery/roles/Murderers.nut")
IncludeScript("murdermystery/roles/Sheriffs.nut")
ClearGameEventCallbacks()
/* TO DO LIST 
	-class system 				[/]
	-option menu				[ ]
	-karma						[/]
	-last player outline		[ ]
	-knife throw 				[/]
*/

::PlayerManager <- Entities.FindByClassname(null, "tf_player_manager");
::GetPlayerUserID <- function(player){
    return NetProps.GetPropIntArray(PlayerManager, "m_iUserID", player.entindex());
 }
::playerlist 			<- []
droppedgun_check_radius <- 110
::StartRoundConvars 	<- function() {
	Convars.SetValue("mp_respawnwavetime", 	999)
	Convars.SetValue("tf_gravetalk", 		0)
 }
::EndRoundConvars 		<- function() {
	Convars.SetValue("mp_respawnwavetime", 	1)
	Convars.SetValue("tf_gravetalk", 		1)
 }

//gamemode roles and role asignment
function giveroles(){
	StartRoundConvars()
	ClientPrint(null, 3, "\x07FFFF76 THE ROUND HAS STARTED.")
	ClientPrint(null, 3, "\x07E10000 murderers\x07FFFFFF must kill all\x0700D500 bystanders\x07FFFFFF and\x070000F0 sheriffs\x07FFFFFF to win,")
	ClientPrint(null, 3, "\x0700D500 bystanders\x07FFFFFF must survive and find artifacts( sapper gibs) to aquire a gun")
	ClientPrint(null, 3, "\x070000F0 sheriffs\x07FFFFFF must protect the\x0700D500 bystanders\x07FFFFFF by shooting the\x07E10000 murderers")
	
	for (local i = 1; i <= Constants.Server.MAX_PLAYERS; i++){
    	local player = PlayerInstanceFromIndex(i)
    	if (player == null) continue
		playerlist.append(player)
		player.SetCurrency(0)
	}
	
	local playercount = playerlist.len()
	if (playercount >= 7) {
		if (MurdererRolesList.len() >= 2) {MurdererRolesList(RandomInt(0, playerlist.len() - 1) ) }
		else{DefaultMurdererClass()}
		if (MurdererRolesList.len() >= 2) {MurdererRolesList(RandomInt(0, playerlist.len() - 1) ) }
		else{DefaultMurdererClass()}
		if (SheriffRolesList.len() >= 2) {SheriffRolesList(RandomInt(0, playerlist.len() - 1) ) }
		else{DefaultSheriffClass()}
		if (SheriffRolesList.len() >= 2) {SheriffRolesList(RandomInt(0, playerlist.len() - 1) ) }
		else{DefaultSheriffClass()}
	}
	else{
		if (SheriffRolesList.len() >= 2) {SheriffRolesList(RandomInt(0, playerlist.len() - 1) ) }
		else{DefaultSheriffClass()}
		if (MurdererRolesList.len() >= 2) {MurdererRolesList(RandomInt(0, playerlist.len() - 1) ) }
		else{DefaultMurdererClass()}
	}
	while(playerlist.len() >= 1){//bystanders
		if (BystanderRolesList.len() >= 2) {
			BystanderRolesList(RandomInt(0, playerlist.len() - 1))
		}
		else{DefaultBystanderClass()}
	}
}

function OnGameEvent_player_death(params){
	local stats = Entities.FindByClassname(null, "tf_player_manager")
	local deadplayer 	= GetPlayerFromUserID(params.userid)
	local deadplayergun = NetProps.GetPropEntityArray(deadplayer, "m_hMyWeapons", 0)
	if (NetProps.GetPropBool(self, "m_bForcedSkin") != false) {NetProps.SetPropBool(self, "m_bForcedSkin", false)}
	AddThinkToEnt(deadplayer, null)

	//gun drop on death
	if (deadplayergun != null) {
		SpawnEntityFromTable("prop_physics_override",{
			targetname  = "dropped_gun",
			Model       = "models/weapons/w_models/w_revolver.mdl",
			solid       = 6,
			modelscale 	= 1.2,
			origin      = deadplayer,
			angles      = "0 0 0",
			vscripts    = "murdermystery/RoleController.nut",
			thinkfunction = "droppedgunthink",
			spawnflags = 4,
			}
		)
	}

	foreach (player in murderers) {
		if(params.userid == GetPlayerUserID(player)) {
			//printl("round end due to murderer dying")
			local roundend = SpawnEntityFromTable("game_round_win", {
    	            TeamNum         = 2, // 2 for red, 3 for blue, 1 for spec
    	            switch_teams    = 0,
    	            force_map_reset = 1,
    	    })
			player.ForceChangeTeam(3, true)
			EndRoundConvars
			EntFireByHandle(roundend, "RoundWin", "", 0.1, roundend, roundend); EntFireByHandle(roundend, "Kill", "", 10, roundend, roundend)
			EndRoundConvars()
		}
	}
}

//dropped gun think script
const RETHINK_TIME = 1
function droppedgunthink(){
	local nearbyplayer 		= Entities.FindByClassnameNearest("player", self.GetOrigin(), droppedgun_check_radius)
	local nearbyplayergun 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 0)
	local nearbyplayerknife = NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 1)

	//gives bystanders gun
	if (nearbyplayer != null) {
		if (nearbyplayergun != null || nearbyplayerknife != null) {
		}
		else{
			nearbyplayer.Regenerate(true)
			local nearbyplayergun 		= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 0)
			local nearbyplayerknife 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 1)
			local nearbyplayersapper 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 2)
			local nearbyplayerpda 		= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 3)
			local nearbyplayerinvis 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 4)
			nearbyplayer.Weapon_SetLast(nearbyplayersapper)
			if (nearbyplayerinvis  	!= null) {sheriffinvis.Kill()}
			if (nearbyplayerpda  	!= null) {nearbyplayerpda.Kill()}
			if (nearbyplayerknife 	!= null) {sheriffknife.Kill()}
			nearbyplayergun.AddAttribute("damage bonus", 10, -1)
			nearbyplayergun.AddAttribute("Reload time decreased", 4.5, -1)
			nearbyplayergun.AddAttribute("fire rate penalty", 1, -1)
			nearbyplayergun.AddAttribute("maxammo secondary increased", 10, -1)
			nearbyplayergun.AddAttribute("mod max primary clip override", 1, -1)
			nearbyplayergun.AddAttribute("cloak consume rate decreased", 1000, -1)
			nearbyplayergun.AddAttribute("cannot disguise", 1, -1)
			nearbyplayergun.SetClip1(1)
			nearbyplayer.RemoveDisguise()
			SendToConsole("slot2")
			self.Kill()
		}
	}
    return RETHINK_TIME
}

//force class change
function OnGameEvent_player_spawn(params){
	local respawnedplayer = GetPlayerFromUserID(params.userid)
	if (respawnedplayer != null && params.team != 1){
		respawnedplayer.ForceChangeTeam(2, true)
		respawnedplayer.SetPlayerClass(8)
		respawnedplayer.Regenerate(true)
		local respawnedplayergun 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 0)
		local respawnedplayerknife 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 1)
		local respawnedplayersapper = NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 2)
		local respawnedplayerpda 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 3)
		local respawnedplayerinvis 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 4)
		if (respawnedplayergun		!= null) {respawnedplayergun.Kill()}
		if (respawnedplayerknife	!= null) {respawnedplayerknife.Kill()}
		if (respawnedplayerpda		!= null) {respawnedplayerpda.Kill()}
		if (respawnedplayerinvis	!= null) {respawnedplayerinvis.Kill()}
		respawnedplayer.Weapon_Switch(respawnedplayersapper)
		if (respawnedplayer.GetScriptThinkFunc() != null) {
			AddThinkToEnt(respawnedplayer, null)
			local spawnedply_cosmetic = null
			while(spawnedply_cosmetic = Entities.FindByClassname(spawnedply_cosmetic, "tf_wearable")){
				if (spawnedply_cosmetic.GetOwner() == respawnedplayer) {
					spawnedply_cosmetic.SetTeam(respawnedplayer.GetTeam())
				}
			}
		}
	}
}


//killfeed mod
ClearGameEventCallbacks()
function OnScriptHook_OnTakeDamage(params) {
	local attackergun		= NetProps.GetPropEntityArray(params.attacker, "m_hMyWeapons", 0)
	local attackerknife 	= NetProps.GetPropEntityArray(params.attacker, "m_hMyWeapons", 1)
	local con_entgun		= NetProps.GetPropEntityArray(params.const_entity, "m_hMyWeapons", 0)
	local con_entknife 		= NetProps.GetPropEntityArray(params.const_entity, "m_hMyWeapons", 1)
	if (params.attacker.GetClassname() == "player" && params.const_entity.GetClassname() == "player") {
		if (GetPlayerUserID(params.attacker) != GetPlayerUserID(params.const_entity)) {
			if (attackergun != null ) {
				if (con_entgun == null && con_entknife == null) {params.attacker.TakeDamageEx(params.attacker, params.attacker, params.attacker, params.attacker.GetOrigin(), params.attacker.GetOrigin(), 999, 1)}
				else if (con_entgun != null) {params.damage = params.const_entity.GetHealth() - 1}
				else if (con_entknife != null) {}
			}
			else if (attackerknife == "tf_weapon_knife" || attackerknife == "saxxy") {
				if (con_entgun == null && con_entknife == null) {params.attacker.TakeDamageEx(params.attacker, params.attacker, params.attacker, params.attacker.GetOrigin(), params.attacker.GetOrigin(), 999, 1)}
				else if (con_entknife == "tf_weapon_knife" || con_entknife == "saxxy") {max_damage = params.const_entity.GetHealth()-1}
				else if (con_entgun == "tf_weapon_revolver") {}
			}
		}
	}
	params.attacker = params.const_entity
}
__CollectGameEventCallbacks(this)