::MurdererRolesList <- []
::murderers 		<- []
::MurdererRoleText 	<- function(target) {
	local gametext = SpawnEntityFromTable("game_text",{
		 		message 	= "You are a Murderer", 
		 		x 			= -1, 
		 		y 			= 0.25,
		 		holdtime 	= 5,
		 		channel 	= 1,
		 		fadein 		= 1,
		 		fadeout 	= 1.5,
		 		color 		= "100 100 100",
		 		color2 		= "240 110 0",
		 		})
	EntFireByHandle(gametext, "Display", "", 0, target, target)
	EntFireByHandle(gametext, "Kill", "", 10, target, target)
}

// > > > > > Murderer class(s) < < < < <
function DefaultMurdererClass() {
    local murderer 		= playerlist.remove(RandomInt(0, playerlist.len() - 1))
	murderers.append(murderer)
	murderer.Regenerate(true)
	local murdergun 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 0)
	local murderknife 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 1)
	local murdersapper 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 2)
	local murderpda 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 3)
	 //murderer settings
		if (murderpda != null) {murderpda.Kill()}
		if (murdergun != null) {murdergun.Kill()}
		
		//add attributes 		//the attribute 	//modifyer   //duration
		murderknife.AddAttribute("cannot disguise", 	1, 			-1)
		murderknife.AddAttribute("damage penalty", 		4, 			-1)
		murderknife.AddAttribute("silent killer ", 		1, 			-1)

		murderer.Weapon_Switch(murdersapper)
		murderer.SetSpyCloakMeter(100)
		murderer.ValidateScriptScope()
		murderer.GetScriptScope().DefaultMurderThink <- DefaultMurderThink
		AddThinkToEnt(murderer, "DefaultMurderThink")
		MurdererRoleText(murderer)
}

// > > > > > Murderer think func(s) < < < < <
::chargetimer 		<- 80
const RETHINK_TIME = 0.1
function DefaultMurderThink() {
	if (chargetimer <= 99) {chargetimer = chargetimer + 1}
	if (GetRoundState() != 4) {AddThinkToEnt(self, null)}
	if (self.GetClassname() == "player") {
		if (NetProps.GetPropBool(self, "m_bForcedSkin") != true) {
			NetProps.SetPropBool(self, "m_bForcedSkin", true)
		}
		if (self.GetActiveWeapon() != null) {
			if (self.IsFakeClient() == false && self.GetActiveWeapon().GetClassname() == "tf_weapon_builder" || self.IsFakeClient() == false && self.GetActiveWeapon().GetClassname() == "tf_weapon_sapper") {
				NetProps.SetPropInt(self, "m_nForcedSkin", 0)
				//printl("holding sapper")
				local murder_cosmetic = null
				while(murder_cosmetic = Entities.FindByClassname(murder_cosmetic, "tf_wearable")){
					if (murder_cosmetic.GetOwner() == self){
					murder_cosmetic.SetTeam(2)
					}
				}
			}
			else if (self.IsFakeClient() == false && self.GetActiveWeapon().GetClassname() == "tf_weapon_knife" || self.IsFakeClient() == false && self.GetActiveWeapon().GetClassname() == "saxxy") {
				NetProps.SetPropInt(self, "m_nForcedSkin",1)
				//printl("holding knife")
				local fake_cosmetic = null
				while(fake_cosmetic = Entities.FindByClassname(fake_cosmetic, "tf_wearable")){
					if (fake_cosmetic.GetOwner() == self){
						fake_cosmetic.SetTeam(3)
					}
				}
			}
		}
		local buttons = NetProps.GetPropInt(self, "m_nButtons")
		local isPressingReload = buttons & Constants.FButtons.IN_RELOAD
		//in Cloak speed increase
		if (self.InCond(4) == true) {
			self.AddCustomAttribute("move speed penalty", 1.4, 0.2)
		}
		 //knife throw
		else if (isPressingReload != 0 && self.GetActiveWeapon().GetClassname() == "tf_weapon_knife" && chargetimer >= 60) {
			//printl("----------Reload Triggered!---------")
			local throwknife = SpawnEntityFromTable("tf_projectile_cleaver", {
    			origin 	= self.EyePosition()+self.EyeAngles().Forward()*50,
    			angles 	= self.EyeAngles(),
			})
			//throwknife.PrecacheModel("models/weapons/w_models/w_knife.mdl")
			throwknife.ApplyAbsVelocityImpulse(self.EyeAngles().Forward()*chargetimer*20)
			throwknife.SetOwner(self)
			throwknife.SetTeam(3)
			//throwknife.SetModel("models/weapons/w_models/w_knife.mdl") //NEED TO PRECOACH!!!
			chargetimer = 0
		}
	}
	return RETHINK_TIME
}